<?php

namespace Scriptor\Modules\SimpleComponents;

use Scriptor\Core\Module;
use Scriptor\Core\Scriptor;
use Scriptor\Module\SimpleComponents\Component;

class Components extends Module
{
    /**
	 * Module version 
	 * 
	 * Use ~~ echo Quill::VERSION; ~~~
	 * to get the current module version
	 */
    const VERSION = '1.0.2';
    
    /**
     * The Components category
     */
    private $components;

    public function init() 
    {
        parent::init();
		Scriptor::load(__DIR__ . '/Component.php');
    }

    /**
     * Select the Component's category 
     */
    private function loadCategory()
    {
        $this->components = $this->imanager->getCategory('name=Components');
    }

    /**
     * Returns a component with a specific name.
     * 
     * @param string $name - Component name
     */
    public function get($name)
    {
        if(!$this->components) $this->loadCategory();

        $item = $this->components->getItem(
            'slug='.$this->sanitizer->pageName($name)
        );

        return ($item) ? new Component($item) : null;        
    }

}